# ################################################################################
# HSE RELEASE AUTOMATION TOOLS - Generic CI Script
# ################################################################################

# include the project-specific variable definitions
include:
  - local: 'rat.yml'

# predefined environment variables (see https://docs.gitlab.com/ee/ci/variables/README.html)
variables: 
    #     CI_PROJECT_DIR				The full path where the repository is cloned and where the job is run.
    #     CI_PROJECT_ID					The unique id of the current project that GitLab CI uses internally
    #     CI_PROJECT_NAME				The project name that is currently being built (actually it is project folder name)
    #     CI_PROJECT_NAMESPACE			The project namespace (username or groupname) that is currently being built
    #     CI_PROJECT_PATH				The namespace with project name
    #     CI_PROJECT_PATH_SLUG			$CI_PROJECT_PATH lowercased and with everything except 0-9 and a-z replaced with -. Use in URLs and domain names.
    #     GITLAB_USER_EMAIL				The email of the user who started the job
    # variables from gitlab-runner (config.toml) 
    #     TOOLS_FOLDER  


# ################################################################################
# HSE RELEASE AUTOMATION TOOLS - Common Variables
# ################################################################################
    #use always the latest commit if the following line is commented out
    #LABVIEW_RAT_VERSION: "vX.Y.Z"
    LABVIEW_RAT_PATH: "\\release-automation-tools\\_dist\\LV"
    EMAIL_SERVER: "mailrelay.edis.at:587"
    EMAIL_ADDR: "ci@hampel-soft.com"
    EMAIL_USER: "ci@hampel-soft.com"
    #EMAIL_PASSWORD is defined in GitLab group secret variables


# ################################################################################
# STAGES  
# ################################################################################
stages:
    - setup
    - init
    - test
    - build
    - distribute



# ################################################################################
# LabVIEW 2014  
# ################################################################################
SetupTools2014:
    stage: setup
    script:
        - rmdir %TOOLS_FOLDER% /s /q
        - git clone git@gitlab.com:hampel-soft/hse-labs/release-automation-tools.git %TOOLS_FOLDER%\release-automation-tools
        #- git -C %TOOLS_FOLDER%\release-automation-tools checkout tags/%LABVIEW_RAT_VERSION% 
    only:
        - /^v[0-9]+\.[0-9]+\..+$/
    tags:
        - "2014"

Dependencies2014:
    stage: init
    script:
        - g-cli --kill --timeout 30000 -v --lv-ver 2014 "%TOOLS_FOLDER%%LABVIEW_RAT_PATH%2014\rat-initializr\rat-initializr.vi" -- "%CI_PROJECT_DIR%" "%CI_PROJECT_NAMESPACE%" LIB
    only:
        - /^v[0-9]+\.[0-9]+\..+$/
    tags:
        - "2014"

Analyzr2014:
    stage: test
    script:
        - g-cli --kill --timeout 30000 -v --lv-ver 2014 "%TOOLS_FOLDER%%LABVIEW_RAT_PATH%2014\rat-analyzr\rat-analyzr.vi" -- "%CI_PROJECT_DIR%" "%CI_PROJECT_NAMESPACE%" LIB
    artifacts:
        paths:
        - artifacts/
    only:
        - /^v[0-9]+\.[0-9]+\..+$/
    tags:
        - "2014"

Buildr2014:
    stage: build
    script:
        # Build (execute buildspec)
        - g-cli --kill --timeout 30000 -v --lv-ver 2014 "%TOOLS_FOLDER%%LABVIEW_RAT_PATH%2014\rat-buildr\rat-buildr.vi" -- "%CI_PROJECT_DIR%" "%CI_PROJECT_NAMESPACE%" LIB
    only:
        - /^v[0-9]+\.[0-9]+\..+$/
    tags:
        - "2014"

PackagrDeployr2014:
    stage: distribute
    script:
        # Package (create .zip archive of project)
        - ping 127.0.0.1 -n 5 -w 1000 >NUL 
        - g-cli --kill --timeout 30000 -v --lv-ver 2014 "%TOOLS_FOLDER%%LABVIEW_RAT_PATH%2014\rat-packagr\rat-packagr.vi" -- "%CI_PROJECT_DIR%" "%CI_PROJECT_NAMESPACE%" LIB
        # Deploy (copy package to shared folder)
        - g-cli --kill --timeout 30000 -v --lv-ver 2014 "%TOOLS_FOLDER%%LABVIEW_RAT_PATH%2014\rat-deployr\rat-deployr.vi" -- "%CI_PROJECT_DIR%" "%CI_PROJECT_NAMESPACE%" LIB
        # Release (publish on webserver)
        - rem g-cli --kill --timeout 30000 -v --lv-ver 2014 "%TOOLS_FOLDER%%LABVIEW_RAT_PATH%2014\rat-releasr\rat-releasr.vi" -- "%CI_PROJECT_DIR%" "%CI_PROJECT_NAMESPACE%" LIB
    only:
        - /^v[0-9]+\.[0-9]+\..+$/
    tags:
        - "2014"


